

#include "PCF8574.h"
#include <SPI.h>
#include <Wire.h>
#include <Adafruit_GFX.h>
#include <Adafruit_SSD1306.h>
#include <DS3231.h>
bool h12;
bool PM;
#define SCREEN_WIDTH 128 // OLED display width, in pixels
#define SCREEN_HEIGHT 32 // OLED display height, in pixels
PCF8574 PCF_27(0x27);  // add switches to lines  (used as input)
PCF8574 PCF_20(0x20);  // add leds to lines      (used as output)
DS3231 Clock ;
#define OLED_RESET     4 // Reset pin # (or -1 if sharing Arduino reset pin)
Adafruit_SSD1306 display(SCREEN_WIDTH, SCREEN_HEIGHT, &Wire, OLED_RESET);


int decArr[60] = {0,  16, 20, 4,  36, 32, 40, 42, 34, 50, 48, 52, 53, 49, 57,
                   56, 58, 26, 24, 28, 60, 61, 45, 44, 46, 62, 30, 22, 54, 55,
                  63,  47, 43, 59, 27, 31, 23, 21, 29, 13, 15, 11, 10, 14, 6,
                  7,  5,  37, 39, 35, 3,  2,  18, 19, 17, 1,  33, 41, 9,  8,
                 };
int x = 32;
int posH, posM ;
int i, j;
int TimeH = 0;
int TimeM = 0;
int BorderH;
int BorderM;
int second, minute, hour;
int framecount2 = 0; //Counter for number of display update periods
unsigned long prev, interval = 100; //Variables for display/clock update rate
byte flash = 0; //Flag for display flashing - toggle once per update interval
byte mode = 0; //Mode for time and date setting
int tempset; //Temporary variable for setting time/date

void setup()
{
  
  display.begin(SSD1306_SWITCHCAPVCC, 0x3C);
  pinMode(6, INPUT);
  pinMode(7, INPUT);
  pinMode(8, OUTPUT);
  pinMode(9, OUTPUT);
  pinMode(10, OUTPUT);
  pinMode(11, OUTPUT);
  digitalWrite(6, HIGH);
  digitalWrite(7, HIGH);
  Serial.begin(9600);
  Wire.begin();
  //Clock.setMinute(3);//Set the minute
  //Clock.setHour(21);  //Set the hour
  //Clock.setSecond(0);
  PCF_27.begin();
  PCF_20.begin();
  PCF_27.write(6, 0);
  PCF_27.write(7, 0);
  PCF_20.write(6, 0);
  PCF_20.write(7, 0);
  //startup() ;
  display.setTextSize(2);             // Draw 2X-scale text
  display.setTextColor(SSD1306_WHITE);
  display.dim(0); 
}

void loop()
{
  unsigned long now = millis(); //Local variable set to current value of Arduino internal millisecond run-time timer
  display.setCursor(0,0); 
  for (i = 0; i < 60; i++) {
    if (PCF_27.read8() == decArr[i]) {
      posH = i;
      
    }
    if (PCF_20.read8() == decArr[i]) {
      posM = 59 - i;
      
    }
  }
  hour = Clock.getHour(h12, PM);
  if (hour  >= 12) {
    hour = hour - 12;
  }
  else {
    hour = hour;
  }
  minute = Clock.getMinute();
  second = Clock.getSecond();
  TimeH = round((hour * 5) + (minute / 12));
  
  if (TimeH - posH < 0) {
    BorderH = 60 + TimeH - posH;
  }
  else {
    BorderH = TimeH - posH;
  }
  TimeM = minute;
  if (TimeM - posM < 0) {
    BorderM = 60 + TimeM - posM;
  }
  else {
    BorderM = TimeM - posM;
  }
  switch (BorderH) {
    case 1 :
      rightH();
       break;
    
    case 2 ... 31:
      rightH_fast();
       break;

       
    case 32 ... 58:
      leftH_fast();
      
      break;
    
    case 59:
      leftH();
      
      break;
    
    case 0:
      stopH();

      break;
  }

  switch (BorderM) {
    case 1:
      rightM();
      
      break;
      case 2 ... 31:
      rightM_fast();
      
      break;
    case 32 ... 58:
      leftM_fast();
      
      break;
    case 59:
      leftM();
      
      break;
    
    case 0:
      stopM();

      break;
  }
  if ((now - prev > 2)) { //Determine whether to start a time and screen update
  framecount2 = framecount2 + 1; //Update counter of refresh periods
  if(framecount2 > 40){
    framecount2 = 0; //Wrap the refresh period counter to 0 after 300 updates, 
    mode = 0; //Reset mode to normal every cycle unless setting buttons pressed to reset cycle counter
    }
  if(flash == 0){flash = 1; }else{flash = 0;} //Toggle flash flag for cursor blinking later
}
if(hour == 0){display.print("12");} //Convert zero hour for 12-hour display
    else if(hour < 13 && hour >= 10){display.print(hour);} //Just display hour if double digit hour
        else if(hour < 10){display.print(" "); display.print(hour);} //If single digit hour, add leading space
        else if(hour >= 13 && hour >= 22){display.print(hour-12);} //If double digit and PM, convert 24 to 12 hour
        else{display.print(" "); display.print(hour-12);} //If single digit and PM, convert to 12 hour and add leading space
        
        display.print(":"); //Display hour-minute separator
        if(minute<10){display.print("0");} //Add leading zero if single-digit minute
        display.print(minute); //Display retrieved minutes
        
        display.print(":"); //Display minute-seconds separator
        if(second<10){display.print("0");} //Add leading zero for single-digit seconds
        display.print(second); //Display retrieved seconds
        display.display();
        display.clearDisplay();
        //Draw and update display every refresh period (100ms)

if(!digitalRead(7)){ //Display rectangle cursor every other display update (5Hz blink)
      delay(100);
      mode=mode+1;
      framecount2 =0;
      }
      switch(mode)
  {
    case 0: break;
    case 1: if(flash){display.drawRect(0,0,25,15,WHITE);}
            if(!digitalRead(6) ){ //Update setting at 5Hz rate if button held down
            delay(100);
            framecount2 =0;
        tempset = hour; //Get the current hour and save in temporary variable
        tempset = tempset + 1; //Increment the hour at 5Hz rate
        if(tempset > 23){tempset = 0;} //Roll over hour after 23rd hour (setting done in 24-hour mode)
        Clock.setHour(tempset);
        
            }
    break;
    case 2: if(flash){display.drawRect(35,0,25,15,WHITE);}
            if(!digitalRead(6) ){ //Update setting at 5Hz rate if button held down
            delay(100);
            framecount2 =0;
        tempset = minute; //Get the current minute and save in temporary variable
        tempset = tempset + 1; //Increment the minute at 5Hz rate
        if(tempset > 59){tempset = 0;} //Roll over hour after 23rd hour (setting done in 24-hour mode)
        Clock.setMinute(tempset);
         }
    break;
    case 3: if(flash){display.drawRect(70,0,25,15,WHITE);}
       if(!digitalRead(6) ){ //Update setting at 5Hz rate if button held down
            delay(100);
            framecount2 =0;
           Clock.setSecond(0); 
        }   
    break;
  }
      

      if(mode>3){mode=0;}


prev = now;
 
 Serial.println(posH); 
}
void stopH() {
  digitalWrite(10, LOW);
  digitalWrite(11, LOW);
  //
}


void rightH() {
  digitalWrite(11, HIGH);
  delay(10); // Approximately 10% duty cycle @ 1KHz
  digitalWrite(11, LOW);
  delay(20);
  
}
void leftH() {
  digitalWrite(10, HIGH);
  delay(10); // Approximately 10% duty cycle @ 1KHz
  digitalWrite(10, LOW);
  delay(20);
  
}
void stopM() {
  digitalWrite(8, LOW);
  digitalWrite(9, LOW);
  
}

void rightM() {
  digitalWrite(9, HIGH);
  delay(10); // Approximately 10% duty cycle @ 1KHz
  digitalWrite(9, LOW);
  delay(20);
  
}
void leftM() {
  digitalWrite(8, HIGH);
  delay(10); // Approximately 10% duty cycle @ 1KHz
  digitalWrite(8, LOW);
  delay(20);
  
}
void rightH_fast() {
  digitalWrite(11, HIGH);
  digitalWrite(10, LOW);
 }
 void leftH_fast() {
  digitalWrite(10, HIGH);
  digitalWrite(11, LOW);
 }
 void rightM_fast() {
  digitalWrite(9, HIGH);
  digitalWrite(8, LOW);
 }
 void leftM_fast() {
  digitalWrite(8, HIGH);
  digitalWrite(9, LOW);
 }
